// $Header: /cvs/gnusto/src/xpcom/engine/gnusto-engine.js,v 1.79 2004/01/03 03:46:24 marnanel Exp $
// Copyright (c) 2004 Thomas Thurman
// thomas@thurman.org.uk
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of version 2 of the GNU General Public License
// as published by the Free Software Foundation.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have be able to view the GNU General Public License at 
// http://www.gnu.org/copyleft/gpl.html ; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
//
try {

  var c=0;

  const ver = "0.5.0";

  // initialize the install with the package name and version
  var err = initInstall(
    "Archangel RGTP client", // the name that will be displayed to the user
    "archangel"  ,           // the path and name under which the software
                             // will appear in the Mozilla/Netscape registry
    ver
  );
  if (err) throw ('initInstall: ' + err);

  var chromeDir     = getFolder("Chrome");
  var componentsDir = getFolder("Components");

  err = addFile("archangel-client.xpt", ver, "archangel-client.xpt", componentsDir , "");
  if (err) throw ('addF 1: ' + err);
  err = addFile("archangel-client.js", ver, "archangel-client.js", componentsDir , "");
  err = addFile("archangel", "archangel-client.js" , componentsDir , "" );
  if (err) throw ('addF 2: ' + err);
  err = addFile("archangel-client.idl", ver, "archangel-client.idl" , componentsDir , "" );
  if (err) throw ('addF 3: ' + err);
  err = addFile("archangel-protocol.js", ver, "archangel-protocol.js", componentsDir , "");
  if (err) throw ('addF 4: ' + err);

  err = addDirectory("" , "archangel", chromeDir, "archangel");
  if (err) throw ('addDirectory: ' + err);

  // register package in chrome registry
  err = registerChrome(
    PACKAGE | DELAYED_CHROME,   // the kind of chrome to register
    chromeDir,                  // where the chrome is being installed into
    "archangel/content/"        // the path to the contents.rdf file in the XPI
  );
  if (err) throw ('registerChrome: ' + err);

  // register locale in chrome registry
  err = registerChrome(
    LOCALE | DELAYED_CHROME,   // the kind of chrome to register
    chromeDir,                 // where the chrome is being installed into
    "archangel/locale/"        // the path to the contents.rdf file in the XPI
  );
  if (err) throw ('registerChrome: ' + err);

  // register skin in chrome registry
  err = registerChrome(
    SKIN | DELAYED_CHROME,     // the kind of chrome to register
    chromeDir,                 // where the chrome is being installed into
    "archangel/skin/"          // the path to the contents.rdf file in the XPI
  );
  if (err) throw ('registerChrome: ' + err);

  // install package
  err = performInstall();
  if (err) throw ('performInstall: ' + err);

} catch(e) {

  logComment(e);      // write the error to Mozilla/bin/install.log
  alert(e);           // and warn the user
  cancelInstall(err); // cancel the installation and return an error
}

